diff --git a/src/lodepng.cpp b/src/lodepng.cpp
index 3bf1d46..98fdf1a 100644
--- a/src/lodepng.cpp
+++ b/src/lodepng.cpp
@@ -3944,8 +3944,8 @@ void LodePNG_encode(LodePNG_Encoder* encoder, unsigned char** out, size_t* outsi
     if((info.color.colorType != 6 && info.color.colorType != 2) || (info.color.bitDepth != 8)) { encoder->error = 59; return; } /*for the output image, only these types are supported*/
     converted = (unsigned char*)malloc(size);
     if(!converted && size) encoder->error = 9955; /*error: malloc failed*/
-    if(!encoder->error) encoder->error = LodePNG_convert(converted, image, &info.color, &encoder->infoRaw.color, w, h);
-    if(!encoder->error) preProcessScanlines(&data, &datasize, converted, &info);/*filter(data.data, converted.data, w, h, LodePNG_InfoColor_getBpp(&info.color));*/
+    if(!encoder->error && converted) encoder->error = LodePNG_convert(converted, image, &info.color, &encoder->infoRaw.color, w, h);
+    if(!encoder->error && converted) preProcessScanlines(&data, &datasize, converted, &info);/*filter(data.data, converted.data, w, h, LodePNG_InfoColor_getBpp(&info.color));*/
     free(converted);
   }
   else preProcessScanlines(&data, &datasize, image, &info);/*filter(data.data, image, w, h, LodePNG_InfoColor_getBpp(&info.color));*/
